// Code created by Alex Wulff
// www.AlexWulff.com

#include <SPI.h>
#include <RF24.h>

// CE, CSN
RF24 radio(9, 10);
int packetID = 0;

const byte addresses[][6] = { "server", "client" };

void setup() {
  Serial.begin(9600);
  radio.begin();
  radio.openWritingPipe(addresses[1]);
  radio.openReadingPipe(1,addresses[0]);
  radio.setPALevel(RF24_PA_MIN);
}

void loop() {
  packetID++; char message[50];
  sprintf(message,"Packet ID: %d",packetID); 

  unsigned long sendTime = micros();
  radio.stopListening();
  bool stat = radio.write(&message, sizeof(message));
  if (stat == 0) {Serial.println("TX Failed!");}
  else {Serial.print("Sent Packet ID: "); Serial.println(packetID);}

  delay(5);
  radio.startListening();  

  bool timeout = false;
  while(!radio.available()) {
    if (micros() - sendTime > 300000) {
      timeout = true;
      Serial.println("Receive Timeout!");
      break;
    }
  }

  if (!timeout) {
    char received[50];
    radio.read(&received, sizeof(received));
    unsigned long roundTripTime = micros() - sendTime;

    Serial.print("ACK Round Trip Time: ");
    Serial.print(roundTripTime);
    Serial.print(" | Message: ");
    Serial.println(received);
  }
 
  delay(500);
}
